Index: trunk/BNC/bnc.pro
===================================================================
--- trunk/BNC/bnc.pro	(revision 119)
+++ trunk/BNC/bnc.pro	(revision 120)
@@ -4,5 +4,5 @@
 DEFINES += NO_RTCM3_MAIN
 
-HEADERS =             bncgetthread.h    bncwindow.h   bnctabledlg.h   \
+HEADERS = bnchelp.html bncgetthread.h    bncwindow.h   bnctabledlg.h   \
           bnccaster.h bncrinex.h bncapp.h bncutils.h                  \
           RTCM/format.h RTCM/GPSDecoder.h RTCM/m_data.h RTCM/RTCM.h   \
Index: trunk/BNC/bnchelp.html
===================================================================
--- trunk/BNC/bnchelp.html	(revision 120)
+++ trunk/BNC/bnchelp.html	(revision 120)
@@ -0,0 +1,71 @@
+"<p>"
+"The BKG NTRIP Client (BNC) is a program for simultaneously accessing real-time"
+"GNSS data streams from several NTRIP broadcasters like www.igs-ip.net (port 80"
+"or 2101) or www.euref-ip.net (port 80 or 2101). "
+"</p>"
+"<p>"
+"The purpose of BNC is to "
+"</p>"
+"<ul>"
+"<li>Generate high-rate RINEX files to feed near real-time post-processing "
+" applications, and</li> "
+"<li>Output synchronize observations through an IP port to feed real-time "
+" applications.</li> "
+"</ul>"
+"<p>"
+"BNC decodes and converts streams carrying phase data coming in "
+"</p>"
+"<ul>"
+"<li> RTCM 2.x format containing message types 18 and 19, </li> "
+"<li> RTCM 3 format containing message types 1001, 1002, 1003, and 1004, "
+"     and </li>"
+"<li> RTIGS format.</li> "
+"</ul>"
+"</p>"
+"<p>"
+"BNC is available for Windows and Linux operating systems and has been "
+"developed under GNU GPL. The options to run BNC are "
+"</p>"
+"<ul>"
+"<li> (a) Proxy host and port (in case of using the program in a proxy-protected"
+"         LAN, optional), </li> "
+"<li> (b) ASCII output file and binary output IP port for synchronized "
+"         observations (optional), </li> "
+"<li> (c) Path for saving the RINEX files (optional), </li> "
+"<li> (d) Skeleton file for RINEX header (4char Station ID, optional), </li> "
+"<li> (e) RINEX file interval (not jet implemented), </li> "
+"<li> (f) Sample interval (not jet implemented), </li> "
+"<li> (g) NTRIP broadcaster host and port, </li> "
+"<li> (h) User-ID and password for access to NTRIP broadcaster. </li> "
+"</ul>"
+"</p>"
+"<p>"
+"Copy the content of archive BNC.tgz into one directory and start BNC.exe. Then"
+"<ol>"
+"<li> Enter parameters (a) to (d), </li> "
+"<li> Open window 'Add Mountpoints' and enter parameters for (g) and (h), </li> "
+"<li> Hit 'Get Table' to receive the NTRIP broadcasters sourcetable, </li> "
+"<li> Select the stream(s) you need by mouse click (+Shift, +Strg), </li> "
+"<li> Hit 'Ok', </li> "
+"<li> Go through (2) to (5) again for streams from another broadcaster "
+" installations, </li> "
+"<li> Hit 'Get data', </li> "
+"<li> Quit execution of BNC. </li> "
+"</ol>"
+"</p>"
+"<p>"
+"Based on a Qt Graphic User Inferface developed by Leos Mervart (TU Prague), "
+"BNC integrates the following already existing software components: "
+"</p>"
+"<ul>"
+"<li> RTCM 2.x decoder by John Sager and Carsten Becker (DLR)</li> "
+"<li> RTCM 3 decoder by Dirk Stoecker (Euronik)</li> "
+"<li> RTIGS decoder by Ken MacLeod (NRCan)</li> "
+"</ul>"
+"</p>"
+"<p>"
+"Note that this is a first version of BNC provided only for test and "
+"evaluation. We are still working on the program and would very much appreciate"
+"if you could send your comments, suggestions, or bug reports to "
+"euref-ip@bkg.bund.de. "
+"</p>"
Index: trunk/BNC/bncwindow.cpp
===================================================================
--- trunk/BNC/bncwindow.cpp	(revision 119)
+++ trunk/BNC/bncwindow.cpp	(revision 120)
@@ -409,15 +409,7 @@
 void bncWindow::slotHelp() {
 
-  QString str("<h3>BNC Help</h3>"
-              "<p>"
-              "Program bnc can be used in interactive mode or "
-              "in a non-interactive mode."
-              "</p>"
-              "<p>"
-              "Non-interactive mode is invoked by -nw switch."
-              "On Unix (Linux) the standard X-window switches "
-              "like -fn 10x20 work. Program appearance can "
-              "be changed by e.g. -style motif switch."
-              "</p>");
+  QString str(
+#include "bnchelp.html"
+              );
 
   QTextBrowser* tb = new QTextBrowser;