Index: trunk/BNC/bncabout.html
===================================================================
--- trunk/BNC/bncabout.html	(revision 174)
+++ trunk/BNC/bncabout.html	(revision 175)
@@ -15,5 +15,5 @@
 <br>
 This software is provided 'as is'.<br>
-Make sure you installed the latest version available from:<br>
+Make sure you installed the latest version available from<br>
 <u>http://igs.bkg.bund.de/index_ntrip_down.htm</u><br>
 <br>
Index: trunk/BNC/bnchelp.html
===================================================================
--- trunk/BNC/bnchelp.html	(revision 174)
+++ trunk/BNC/bnchelp.html	(revision 175)
@@ -8,9 +8,11 @@
 <p>
 <h3>Contents</h3>
-<h4><a href=#purpose>A - Purpose<br>
+<h4>
+<a href=#purpose>A - Purpose<br>
 <a href=#options>B - Options<br>
 <a href=#limits>C - Limitations<br>
 <a href=#authors>D - Authors<br>
-<a href=#annex>E - Annex</h4>
+<a href=#annex>E - Annex<br>
+</h4>
 </p>
 <br>
@@ -30,5 +32,5 @@
 <ul>
 <li> RTCM <a href=#rtcm2>Version 2.x</a> Format containing message types 18 and 19, </li> 
-<li> RTCM <a href=#rtcm3>Version 3</a> Format containing message types 1001, 1002, 1003, and 1004, and</li>
+<li> RTCM <a href=#rtcm3>Version 3</a> Format containing message types 1001, 1002, 1003, and 1004,</li>
 <li> <a href=#rtigs>RTIGS</a> Format.</li> 
 </ul>
@@ -36,5 +38,5 @@
 
 <p>
-BNC is available for Windows, Linux, and Solarix systems. It has been developed under GNU General Public License.
+BNC is available for Windows, Linux, and Solaris systems. It has been developed under GNU General Public License.
 </p>
 
@@ -97,5 +99,5 @@
 <li>
 Help Contents.<br>
-You may keep the 'Help Contens' window open while setting BNC options.
+You may keep the 'Help Contents' window open while setting BNC options.
 </li> 
 </ul>
@@ -106,7 +108,7 @@
 
 <p>
-You may like to run BNC on a host in a Local Area Network (LAN). LAN's are often protected by a proxy server. Enter your proxy server IP and port number in case one is operated in front of you. In case you don't know the IP and port of your proxy server, check out the proxy server settings of your Windows browser or ask your network administator.</p>
-<p>
-Note that IP-streaming may be generally denied in a LAN. In such a case you need to contact your network administator for an appropriate modification of your security policy or the installation of a TCP relay to involved NTRIP broadcasters. If that doesn't work out, run BNC on a host that is connected to the Internet through an Internet Service Provider (ISP).
+You may like to run BNC on a host in a Local Area Network (LAN). LAN's are often protected by a proxy server. Enter your proxy server IP and port number in case one is operated in front of you. In case you don't know the IP and port of your proxy server, check out the proxy server settings of your Windows browser or ask your network administrator.</p>
+<p>
+Note that IP-streaming may be generally denied in a LAN. In such a case you need to contact your network administrator for an appropriate modification of your security policy or the installation of a TCP relay to involved NTRIP broadcasters. If that doesn't work out, run BNC on a host that is connected to the Internet through an Internet Service Provider (ISP).
 </p>
 
@@ -120,5 +122,5 @@
 <p><h4>B - 4.1 Wait for Full Epoch</h4></p>
 <p>
-When feeding a real-time GNSS engine waiting for input epoch by epoch, BNC ignores whatever is received latern then 'Wait for full epoch' seconds. A value of 2 to 5 seconds may be an appropriate choise for that, depending on the delay you can accept for your real-time product. Note that 'Wait for full epoch' does not influence the RINEX file contents. Observations coming in later than 'Wait for full epoch' will still be included there.
+When feeding a real-time GNSS engine waiting for input epoch by epoch, BNC ignores whatever is received later then 'Wait for full epoch' seconds. A value of 2 to 5 seconds may be an appropriate choice for that, depending on the delay you can accept for your real-time product. Note that 'Wait for full epoch' does not influence the RINEX file contents. Observations coming in later than 'Wait for full epoch' will still be included there.
 </p> 
 
@@ -132,5 +134,5 @@
 <p><h4>B - 4.3 Port for Binary Output</h4></p>
 <p>
-BNC outputs synchronized observations in a binary format through an IP port with the following format: ..... Souce code of an example program 'test_bnc.cpp' that reads the binary data to feed real-time GNSS applications is available.
+BNC outputs synchronized observations in a binary format through an IP port with the following format: ..... Source code of an example program 'test_bnc.cpp' that reads the binary data to feed real-time GNSS applications is available.
 </p> 
 
@@ -140,5 +142,5 @@
 Observations are converted to RINEX format version 2.1. Note that RINEX file names are derived by BNC from the first 4 characters of the corresponding mountpoint (4Char Station ID). Thus, retrieving data from mounpoints FFMJ1 and KARL0 leads to RINEX files named FFMJ*.* and KARL*.*.</p>
 <p>
-In case you retrieve straeams that show mountpoints with an identical 4Char Station ID, the full mountpoint string will become part of the RINEX file name. Example: When simultaneously retrieving mountpoints FFMJ1 and FFMJ3, there RINEX file names will be FFMJ*_1.* and FFMJ*_3.*.
+In case you retrieve streams that show mountpoints with an identical 4Char Station ID, the full mountpoint string will become part of the RINEX file name. Example: When simultaneously retrieving mountpoints FFMJ1 and FFMJ3, there RINEX file names will be FFMJ*_1.* and FFMJ*_3.*.
 </p>
 
@@ -152,5 +154,5 @@
 <p><h4>B - 5.2 RINEX Script</h4></p>
 <p>
-Whenever a RINEX file is generated, you may like to compress, copy, or upload it immediately. For that you enter the full path of a script or bach file carrying out these operations. The RINEX file name will be passed to the script as a command line parameter. Note the following example for a 'RINEX Script' file: ${HOME}/upload_script
+Whenever a RINEX file is generated, you may like to compress, copy, or upload it immediately. For that you enter the full path of a script or batch file carrying out these operations. The RINEX file name will be passed to the script as a command line parameter. Note the following example for a 'RINEX Script' file: ${HOME}/upload_script
 </p> 
 
@@ -179,5 +181,5 @@
 </li>
 <li>
-Concerning RTCM Version 3 streams: If the ambiguity field is not set, the output will be no valid RINEX. All values will be stored modulo 299792.458. A COMMENT line will tell you, when this happens. It would be necessary to approximately calculate the range to fix the ambiguity (needing ephemeris/alamanac and easy positioning algorithm).
+Concerning RTCM Version 3 streams: If the ambiguity field is not set, the output will be no valid RINEX. All values will be stored modulo 299792.458. A COMMENT line will tell you, when this happens. It would be necessary to approximately calculate the range to fix the ambiguity (needing ephemeris/almanac and easy positioning algorithm).
 </li>
 </ul>
@@ -185,5 +187,5 @@
 </p>
 <p>
-Example: Moutpoints FFMJ1 and KARL0 lead to the generation of RINEX files FFMJ*.* and KARL*.*. The header part of these files would be overwritten by the content of the skeleton files FFMJ.skl and KARL.skl in case 'RINEX skeletion extension" is set to 'skl' .
+Example: Moutpoints FFMJ1 and KARL0 lead to the generation of RINEX files FFMJ*.* and KARL*.*. The header part of these files would be overwritten by the content of the skeleton files FFMJ.skl and KARL.skl in case 'RINEX skeleton extensionis set to 'skl' .
 </p> 
 
@@ -197,5 +199,5 @@
 <p><h4>B - 6.1 Add Mountpoints</h4></p>
 <p>
-Buttone 'Add Mountpoints' opens a window that lets you select data streams by their mountpoint.
+Button 'Add Mountpoints' opens a window that lets you select data streams by their mountpoint.
 </p> 
 
@@ -221,7 +223,7 @@
 <p><h4>B - 7. Delete Mountpoints</h4></p>
 <p>
-To delete a stream shown under 'Mountpoints' in BNC's main windows select it by mouse click and hit 'Delete Mountpoints'. You may tag more than one stream for simultaneous delition through using +Shift and +Strg.</p>
-<p>
-BNC automatically selectes the decoder for a stream based on the 'format' and 'format-details' given in the sourcetable. It may happen that you need to overrule this decoder selection because of sourcetable setup deficiencies. Therefore BNC allows to edit the decoder part for each stream shown under 'Mountpoints'. Accepted decoder strings are are 'RTCM 2.x', 'RTCM 3', and 'RTIGS'.
+To delete a stream shown under 'Mountpoints' in BNC's main windows select it by mouse click and hit 'Delete Mountpoints'. You may tag more than one stream for simultaneous deletion through using +Shift and +Strg.</p>
+<p>
+BNC automatically selects the decoder for a stream based on the 'format' and 'format-details' given in the sourcetable. It may happen that you need to overrule this decoder selection because of sourcetable setup deficiencies. Therefore BNC allows to edit the decoder part for each stream shown under 'Mountpoints'. Accepted decoder strings are are 'RTCM 2.x', 'RTCM 3', and 'RTIGS'.
 </p> 
 
@@ -229,5 +231,5 @@
 <p><h4>B - 8. Log File</h4></p>
 <p>
-BNC's comments its activities in the 'Log file' section on the main windows. All comments can be saved and concatinated in a file through entering the full path of 'Log file'. Information is given about the dialog with the NTRIP broadcaster as well as any problem that might occure concering communication, stream availability, stream delay, stream conversion etc.
+BNC's comments its activities in the 'Log file' section on the main windows. All comments can be saved and concatenated in a file through entering the full path of 'Log file'. Information is given about the dialog with the NTRIP broadcaster as well as any problem that might occur concerning communication, stream availability, stream delay, stream conversion etc.
 </p>
 <p>
@@ -264,5 +266,5 @@
 <p><h3>D - Authors</h3></p>
 <p>
-Based on a Qt Graphic User Inferface (GUI) developed for BKG by Leos Mervart (TU Prague), BNC integrates the following already existing GNU GPL software components: 
+Based on a Qt Graphic User Interface (GUI) developed for BKG by Leos Mervart (TU Prague), BNC integrates the following already existing GNU GPL software components: 
 <ul>
 <li> RTCM 2.x decoder, written by John Sager with contributions from Carsten Becker (DLR)</li> 
@@ -303,5 +305,5 @@
 
 <p>
-NTRIP is an RTCM standard designed for disseminating differential correction data (e.g in the RTCM-104 format) or otherkinds of GNSS streaming data to stationary or mobile users over the Internet, allowing simultaneous PC, Laptop, PDA, orreceiver connections to a broadcasting host. NTRIP supports wireless Internet access through Mobile IP Networks like GSM, GPRS, EDGE, or UMTS.
+NTRIP is an RTCM standard designed for disseminating differential correction data (e.g in the RTCM-104 format) or other kinds of GNSS streaming data to stationary or mobile users over the Internet, allowing simultaneous PC, Laptop, PDA, or receiver connections to a broadcasting host. NTRIP supports wireless Internet access through Mobile IP Networks like GSM, GPRS, EDGE, or UMTS.
 </p>
 
@@ -316,5 +318,5 @@
 <li>Application not limited to one particular plain or coded stream content; ability to distribute any kind of GNSS data.</li>
 <li>Potential to support mass usage; disseminating hundreds of streams simultaneously for up to thousand users possible when applying modified Internet Radio broadcasting software.</li>
-<li>Considering security needs; stream providers and users don't necessarily get into contact, streams often not blocked by firewalls or proxyservers protecting Local Area Networks.</li>
+<li>Considering security needs; stream providers and users don't necessarily get into contact, streams often not blocked by firewalls or proxy servers protecting Local Area Networks.</li>
 <li>Enables streaming over any mobile IP network because of using TCP/IP.</li>
 </ul>
@@ -328,5 +330,5 @@
 </p>
 
-<p>Records of type STR contain the following data fields: mountpoint, identifier, format, format-details,  carrier, nav-system, network, country,  latitude, longitude, nmea, solution, generator, compr-encryp, authentication, fee, bitrate, misc. Note that BNC's 'Get Table' only shows STR records of a sourcetable. You may like to use a Windows broswer to retrieve the full sourcetable content entering the URL http://host:port/dummy.
+<p>Records of type STR contain the following data fields: mountpoint, identifier, format, format-details,  carrier, nav-system, network, country,  latitude, longitude, nmea, solution, generator, compr-encryp, authentication, fee, bitrate, misc. Note that BNC's 'Get Table' only shows STR records of a sourcetable. You may like to use a Windows browser to retrieve the full sourcetable content entering the URL http://host:port/dummy.
 </p>
 
@@ -352,5 +354,5 @@
 </li>
 <li>
-Tpye 3 and 22 messages are the base station position and the antenna offset. Type 3 and 22 are used in RTK processing to perform antenna reduction.
+Type 3 and 22 messages are the base station position and the antenna offset. Type 3 and 22 are used in RTK processing to perform antenna reduction.
 </li>
 <li>
@@ -408,5 +410,5 @@
 </li>
 <li>
-Type 1009 message carres GLONASS L1 code and phase.
+Type 1009 message carries GLONASS L1 code and phase.
 </li>
 <li>
@@ -420,5 +422,5 @@
 </li>
 <li>
-Type 1013 message carries Modified julian date, leep second, configured message types and intervall.
+Type 1013 message carries Modified julian date, leap second, configured message types and interval.
 </li>
 <li>
@@ -442,4 +444,5 @@
 <p><h4>E - 3. RTIGS</h4></p>
 <p>
+Input from by Ken?
 </p>
 
@@ -447,3 +450,5 @@
 <p><h4>E - 3.1 SOC</h4></p>
 <p>
-</p>
+Input from by Ken?
+</p>
+